<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onLoadCar();
    onLoadCountry();
    $("#car-select").on("change", function () {
      onLoadTypeCar(this);
    })

    // change region
    $("#country-select").on("change", function () {
      onLoadRegionType(this);
    })

    $("#btn-send").on("click", function () {
      onBtnSend();
    })

  })


  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // load dữ liệu car
  function onLoadCar() {
    var vSelectCarObj = $("#car-select");
    for (var bI = 0; bI < gObjectCarData.length; bI++) {
      $("<option/>", {
        "value": gObjectCarData[bI].brandId,
        "text": gObjectCarData[bI].brandName
      }).appendTo(vSelectCarObj);
    }
  }
  // load dữ liệu country
  function onLoadCountry() {
    var vSelectCountryObj = $("#country-select");

    for (var bI = 0; bI < gObjectCountryData.length; bI++) {
      $("<option/>", {
        "value": gObjectCountryData[bI].countryId,
        "text": gObjectCountryData[bI].countryName
      }).appendTo(vSelectCountryObj)
    }
  }
  // load dữ liệu type car
  function onLoadTypeCar(paramCar) {

    var vSelectTypeCar = $("#car-type-select");
    var vCarId = $(paramCar).val();
    var vBrandTypes = getBrandTypeByBrandID(vCarId);
    vSelectTypeCar.html("");
    if (vCarId == 0) {
      $("#car-type-select").prop("disabled", true);
      alert("hayx chon xe");
    }
    for (var bI = 0; bI < vBrandTypes.length; bI++) {
      $("#car-type-select").prop("disabled", false);

      $("<option/>", {
        "value": vBrandTypes[bI].typeId,
        "text": vBrandTypes[bI].typeName
      }).appendTo(vSelectTypeCar)
    }

  }
  // load data regionType
  function onLoadRegionType(paramCountry) {
    var vSelectRegion = $("#region-type-select");
    var vTypeId = $(paramCountry).val();
    var vRegionType = getRegionTypeByRegionId(vTypeId);
    vSelectRegion.html("");
    if (vTypeId == 0) {
      vSelectRegion.prop("disabled", true);
      alert("hay chon country");
    }
    for (var bI = 0; bI < vRegionType.length; bI++) {
      vSelectRegion.prop("disabled", false);
      $("<option/>", {
        "value": vRegionType[bI].regionId,
        "text": vRegionType[bI].regionName
      }).appendTo(vSelectRegion)
    }

  }
  // an nut send
  function onBtnSend() {
    var vInfoObj = {
      firstName: "",
      lastName: "",
      country: "",
      region: "",
      car: "",
      typeCar: "",
    };
    thuThapThongTin(vInfoObj);
    var vCheck = kiemTraThongTin(vInfoObj);
    if (vCheck) {
      hienThiThongTin(vInfoObj);
    }
  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }
  // chon region
  function getRegionTypeByRegionId(paramRegionId) {
    var vTimThay = false;
    var vI = 0;
    var vRegionResuit = null
    while (!vTimThay && vI < gObjectCountryData.length) {
      if (paramRegionId == gObjectCountryData[vI].countryId) {
        vTimThay = true;
        vRegionResuit = gObjectCountryData[vI].regionTypes;
      }
      else {
        vI++;
      }
    }
    return vRegionResuit;
  }

  // thu thap thong tin
  function thuThapThongTin(paramInfo) {
    paramInfo.firstName = $("#input-fname").val();
    paramInfo.lastName = $("#input-lname").val();

    paramInfo.country = $("#country-select option:selected").text();
    paramInfo.region = $("#region-type-select option:selected").text();
    paramInfo.car = $("#car-select option:selected").text();
    paramInfo.typeCar = $("#car-type-select option:selected").text();
  }
  // kiem tra thong tin
  function kiemTraThongTin(paramInfo) {
    if (paramInfo.firstName == "" || paramInfo.lastName == "") {
      alert("hay nhap first name va last name");
      return false;
    }
    else if (paramInfo.country == "None" || paramInfo.car == "None") {
      alert("hay chon car va country");
      return false;
    }
    return true;
  }
  // hien thi thong tin
  function hienThiThongTin(paramInfo) {
    console.log(paramInfo.firstName);
    console.log(paramInfo.lastName);
    console.log(paramInfo.country);
    console.log(paramInfo.car);
    console.log(paramInfo.typeCar);
    console.log(paramInfo.region);
  }

</script>

</html>